﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace TasksAndLamdas_Prednaska {
	class Program {
		const int Count = 3;

		static void Test0() {
			var done = new CountdownEvent(Count);
			int total = 0;

			for (int i = 0; i < Count; i++) {
				Task.Run(() => {
					total += i;
					done.Signal();
				});
			}

			done.Wait();

			Console.WriteLine("Tasks say: {0}", total);
		}

		static void Test1() {
			var done = new CountdownEvent(Count);
			int total = 0;
		
			for (int i = 0; i < Count; i++) {
				Task.Run(() => {
					Interlocked.Add(ref total, i);
					done.Signal();
				});
			}

			done.Wait();

			Console.WriteLine("Tasks say: {0}", total);
		}

		static void Test2() {
			var done = new CountdownEvent(Count);
			int total = 0;

			int i = 0;
			while (i < Count) {
				Task.Run(() => {
					Interlocked.Add(ref total, i);
					done.Signal();
				});

				i++;
			}

			done.Wait();

			Console.WriteLine("Tasks say: {0}", total);
		}

		static void Test3() {
			var done = new CountdownEvent(Count);
			int total = 0;
		
			for (int i = 0; i < Count; i++) {
				int value = i;
				Task.Run(() => {
					Interlocked.Add(ref total, value);
					done.Signal();
				});
			}

			done.Wait();

			Console.WriteLine("Tasks say: {0}", total);
		}

		static void Main(string[] args) {
			Test0();
			Test1();
			Test2();
			Test3();
		}
	}
}
